//+------------------------------------------------------------------+
//|                                                LSMA _rainbow.mq4 |
//|                                                             Swan |
//|                                  http://ruforum.forexpeoples.com |
//|                                                           eugenk |
//|                                     http://forum.mql4.com/ru/9154|
//|                                                       Dm_35 2008 |
//|                                        http://dm-fx.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Dm_35"
#property link      "dm34@mail.ru"
#property indicator_chart_window

extern int KPeriod=10;

extern int Step=1;//  KPeriod
extern int Count=70;// 
extern int Limit=400;//   


int m;
string Name;
color Color=0;
int rainbow[10000];  //  
int nRainbow;        //  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if(Count>70) Count=70;
   Name="Lsma("+KPeriod+")";
   IndicatorShortName(Name);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   DeleteLine();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
double ArrayMain[][50];
DeleteLine(); m=0;


   ArrayResize(ArrayMain,Limit);
   for(int i=0;i<Limit;i++)
      {
      for(int n=0;n<Count;n++)
         {
         ArrayMain[i][n]=3*iMA(NULL,0,KPeriod+n*Step,0,MODE_LWMA, PRICE_CLOSE,i)-
                         2*iMA(NULL,0,KPeriod+n*Step,0,MODE_SMA,  PRICE_CLOSE,i);
         //ArrayMain[i][n]=iMA(NULL,0,KPeriod+n*Step,0,method,0,i);
         }
      }
nRainbow=BuildRainbow();
int c;

   for(n=0;n<Count;n++)
      {
      for(i=0;i<Limit-1;i++)
         {
         c=GetRainbowColor(n);
         DrawLine(ArrayMain[i][n],ArrayMain[i+1][n],c,i);
         }
      }
WindowRedraw();
   return(0);
  }
//+------------------------------------------------------------------+
void DrawLine(double Var1,double Var2,int c,int i)
   {
   ObjectCreate("line"+m,OBJ_TREND,0,Time[i],Var1,Time[i+1],Var2);
   ObjectSet("line"+m,OBJPROP_RAY,false);
   ObjectSet("line"+m,OBJPROP_COLOR,c);
   m++;
   }
void DeleteLine()
   {
   for(int i=0;i<m;i++)
   ObjectDelete("line"+i);
   }
   
int GetRGB(int r, int g, int b)
{//    r, g, b
   return (256*(256*b + g) + r);
}

int BuildRainbow()
{// ,   
//      :)
   int r=255, g=0, b=0;
   int n=0;
   
   while(g !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      g++; n++;
   }   
   while(r !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      r--; n++;
   }
   while(b !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      b++; n++;
   }
   while(g !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      g--; n++;
   }
   while(r !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      r++; n++;
   }
   return (n);   
}

int GetRainbowColor(int c)
{//    
   double k=nRainbow/Count;
   int n=c*k;
   return (rainbow[n]);
}   